Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.math3.geometry.partitioning
Interface Region<S extends Space>

Type Parameters:
  `S` - Type of the space.

All Known Implementing Classes:
  AbstractRegion, IntervalsSet, PolygonsSet, PolyhedronsSet

    public interface Region<S extends Space>

This interface represents a region of a space as a partition.

Region are subsets of a space, they can be infinite (whole space, half space, infinite stripe ...) or finite (polygons in 2D, polyhedrons in 3D ...). Their main characteristic is to separate points that are considered to be inside the region from points considered to be outside of it. In between, there may be points on the boundary of the region.

This implementation is limited to regions for which the boundary is composed of several `sub-hyperplanes`, including regions with no boundary at all: the whole space and the empty region. They are not necessarily finite and not necessarily path-connected. They can contain holes.

Regions can be combined using the traditional sets operations : union, intersection, difference and symetric difference (exclusive or) for the binary operations, complement for the unary operation.

Since:
  3.0
Version:
  $Id: Region.java 1416643 2012-12-03 19:37:14Z tn $

Nested Class Summary
`static class` | `Region.Location` Enumerate for the location of a point with respect to the region.

Method Summary
`Region<S>` | `buildNew(BSPTree<S> newTree)` Build a region using the instance as a prototype.
`Region.Location` | `checkPoint(Vector<S> point)` Check a point with respect to the region.
`boolean` | `contains(Region<S> region)` Check if the instance entirely contains another region.
`Region<S>` | `copySelf()` Copy the instance.
`Vector<S>` | `getBarycenter()` Get the barycenter of the instance.
`double` | `getBoundarySize()` Get the size of the boundary.
`double` | `getSize()` Get the size of the instance.
`BSPTree<S>` | `getTree(boolean includeBoundaryAttributes)` Get the underlying BSP tree.
`SubHyperplane<S>` | `intersection(SubHyperplane<S> sub)` Get the parts of a sub-hyperplane that are contained in the region.
`boolean` | `isEmpty()` Check if the instance is empty.
`boolean` | `isEmpty(BSPTree<S> node)` Check if the sub-tree starting at a given node is empty.
`Side` | `side(Hyperplane<S> hyperplane)` Compute the relative position of the instance with respect to an hyperplane.

Method Detail

### buildNew

    Region<S> buildNew(BSPTree<S> newTree)

  Build a region using the instance as a prototype.

  This method allow to create new instances without knowing exactly the type of the region. It is an application of the prototype design pattern.

  The leaf nodes of the BSP tree must have a `Boolean` attribute representing the inside status of the corresponding cell (true for inside cells, false for outside cells). In order to avoid building too many small objects, it is recommended to use the predefined constants `Boolean.TRUE` and `Boolean.FALSE`. The tree also must have either null internal nodes or internal nodes representing the boundary as specified in the `getTree` method).

  Parameters:
    `newTree` - inside/outside BSP tree representing the new region
  Returns:
    the built region

### copySelf

    Region<S> copySelf()

  Copy the instance.

  The instance created is completely independant of the original one. A deep copy is used, none of the underlying objects are shared (except for the underlying tree `Boolean` attributes and immutable objects).

  Returns:
    a new region, copy of the instance

### isEmpty

    boolean isEmpty()

  Check if the instance is empty.

  Returns:
    true if the instance is empty

### isEmpty

    boolean isEmpty(BSPTree<S> node)

  Check if the sub-tree starting at a given node is empty.

  Parameters:
    `node` - root node of the sub-tree (must have `Region` tree semantics, i.e. the leaf nodes must have `Boolean` attributes representing an inside/outside property)
  Returns:
    true if the sub-tree starting at the given node is empty

### contains

    boolean contains(Region<S> region)

  Check if the instance entirely contains another region.

  Parameters:
    `region` - region to check against the instance
  Returns:
    true if the instance contains the specified tree

### checkPoint

    Region.Location checkPoint(Vector<S> point)

  Check a point with respect to the region.

  Parameters:
    `point` - point to check
  Returns:
    a code representing the point status: either `Region.Location.INSIDE`, `Region.Location.OUTSIDE` or `Region.Location.BOUNDARY`

### getTree

    BSPTree<S> getTree(boolean includeBoundaryAttributes)

  Get the underlying BSP tree.

  Regions are represented by an underlying inside/outside BSP tree whose leaf attributes are `Boolean` instances representing inside leaf cells if the attribute value is `true` and outside leaf cells if the attribute is `false`. These leaf attributes are always present and guaranteed to be non null.

  In addition to the leaf attributes, the internal nodes which correspond to cells split by cut sub-hyperplanes may contain `BoundaryAttribute` objects representing the parts of the corresponding cut sub-hyperplane that belong to the boundary. When the boundary attributes have been computed, all internal nodes are guaranteed to have non-null attributes, however some `BoundaryAttribute` instances may have their `plusInside` and `plusOutside` fields both null if the corresponding cut sub-hyperplane does not have any parts belonging to the boundary.

  Since computing the boundary is not always required and can be time-consuming for large trees, these internal nodes attributes are computed using lazy evaluation only when required by setting the `includeBoundaryAttributes` argument to `true`. Once computed, these attributes remain in the tree, which implies that in this case, further calls to the method for the same region will always include these attributes regardless of the value of the `includeBoundaryAttributes` argument.

  Parameters:
    `includeBoundaryAttributes` - if true, the boundary attributes at internal nodes are guaranteed to be included (they may be included even if the argument is false, if they have already been computed due to a previous call)
  Returns:
    underlying BSP tree
  See Also:
    `BoundaryAttribute`

### getBoundarySize

    double getBoundarySize()

  Get the size of the boundary.

  Returns:
    the size of the boundary (this is 0 in 1D, a length in 2D, an area in 3D ...)

### getSize

    double getSize()

  Get the size of the instance.

  Returns:
    the size of the instance (this is a length in 1D, an area in 2D, a volume in 3D ...)

### getBarycenter

    Vector<S> getBarycenter()

  Get the barycenter of the instance.

  Returns:
    an object representing the barycenter

### side

    Side side(Hyperplane<S> hyperplane)

  Compute the relative position of the instance with respect to an hyperplane.

  Parameters:
    `hyperplane` - reference hyperplane
  Returns:
    one of `Side.PLUS`, `Side.MINUS`, `Side.BOTH` or `Side.HYPER` (the latter result can occur only if the tree contains only one cut hyperplane)

### intersection

    SubHyperplane<S> intersection(SubHyperplane<S> sub)

  Get the parts of a sub-hyperplane that are contained in the region.

  The parts of the sub-hyperplane that belong to the boundary are not included in the resulting parts.

  Parameters:
    `sub` - sub-hyperplane traversing the region
  Returns:
    filtered sub-hyperplane

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2013 The Apache Software Foundation. All Rights Reserved.